Prime Path [bfs]

来源:互联网 发布:mac桌面文件夹灰色的 编辑:程序博客网 时间:2024/06/09 14:14

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

bfs

直接根据题意走一遍就行了

#include<stdio.h>#include<string.h>#include<queue>#define MAX_N 10000#define MIN_N 1000using namespace std;bool prim[MAX_N];int best[MAX_N];int M[]={1,10,100,1000,10000};void init(){    memset(prim,true,sizeof(prim));    for(int i=2;i*i<=MAX_N;i++)        if(prim[i])            for(int j=i*i;j<=MAX_N;j+=i)                prim[j]=false;}int bfs(int s,int e){    memset(best,-1,sizeof(best));    queue<int> que;//now    que.push(s);    best[s]=0;    while(!que.empty()){        int t=que.front();que.pop();        int cnt=best[t];        if(t==e) return cnt;        for(int i=0;i<4;i++){            int tmp=(t%M[i+1])/M[i];            for(int j=1;j<10-tmp;j++){                int k=j*M[i]+t;                if(best[k]==-1&&prim[k]){                    best[k]=cnt+1;                    que.push(k);                }            }            for(int j=1;j<=tmp;j++){                int k=-j*M[i]+t;                if(k>MIN_N&&best[k]==-1&&prim[k]){                    best[k]=cnt+1;                    que.push(k);                }            }        }    }    return -1;}int main(){    int T,s,e;init();    scanf("%d",&T);    while(T--){        scanf("%d%d",&s,&e);        int ans=bfs(s,e);        if(ans>=0) printf("%d\n",ans);        else puts("Impossible");    }    return 0;}
0 0
原创粉丝点击